import codeanticode.syphon.*;
import oscP5.*;
import netP5.*;


PGraphics canvas;
SyphonServer server;
OscP5 oscP5;
NetAddress myBroadcastLocation;
float factor;


void setup()
{
  // DISPLAY SETUP
  size(640, 480, P3D);
  canvas = createGraphics(width, height, P3D);
  initTheScene();
  // SYPHON SETUP
  server = new SyphonServer(this, "Processing Cube");
  // OSC SETUP
  oscP5 = new OscP5(this, 5001);
  myBroadcastLocation = new NetAddress("127.0.0.1", 5000);
  factor = 1;
}


// RENDER AND SEND TO SYPHON
void draw()
{
  canvas.beginDraw();
  renderTheScene();
  canvas.endDraw();
  image(canvas, 0, 0);
  server.sendImage(canvas);
}


// SEND ORDER TO MILLUMIN
void mouseMoved()
{
  OscMessage myOscMessage = new OscMessage("/millumin/layer/opacity/0");
  myOscMessage.add(100*mouseX/width);
  oscP5.send(myOscMessage, myBroadcastLocation);
}


// RECEIVE ORDER FROM MILLUMIN
void oscEvent(OscMessage theOscMessage)
{
  if ( theOscMessage.addrPattern().equals("/millumin/layer/scale/0") )
  {
    factor = theOscMessage.get(0).floatValue()/100;
  }
}



















//--------------------------------------

int nBranches = 6;
float startingLength = 290;
float phasor = 0.0;
float rate = 0.0005;
color bg = color(0, 8);
 
PVector getVCoordinates(PVector v, float d, float a) {
  return new PVector(v.x + d * cos(a), v.y + d * sin(a));
}
 
void initTheScene() {
 
 
}
 
void renderTheScene() {
   background(0);
  noStroke();
  rect(0, 0, width, height);
 
  float sine = sin(phasor * TWO_PI);
  float angle = map(sine, -1.0, 1.0, -HALF_PI, HALF_PI);
  float divPoint = map(sine, -1.0, 1.0, 1.0, 0.5);
   
  for (int i = 0; i < nBranches; i++) {
    float L = startingLength;
    float a = TWO_PI / (float) nBranches * (float) i;
    PVector v1 = new PVector(width / 2, height / 2);
    PVector v2 = getVCoordinates(v1, L, a);
     
    while (L > 2) {
      canvas.stroke(random(255), 255, 0, 32);
      L *= 0.95;
       
      canvas.line(v1.x, v1.y, v2.x, v2.y);
      a += angle;
     
      v1.x = lerp(v1.x, v2.x, divPoint);
      v1.y = lerp(v1.y, v2.y, divPoint);
       
      v2 = getVCoordinates(v1, L, a);
    }
  }
 
  phasor += rate;
  if (phasor >= 1.0) {
    phasor -= 1.0;
  }
}

